%global original_gem_name occi-core
%global gem_name occi-core4

Name:           rubygem-%{gem_name}
Version:        4.3.5
Release:        3%{?dist}
Summary:        OCCI toolkit

Group:          Development/Languages
License:        ASL 2.0
URL:            https://github.com/EGI-FCTF/rOCCI-core
Source0:        https://rubygems.org/gems/%{original_gem_name}-%{version}.gem
# Quick hack fix for FTBFS RB #1308057
# Ruby upstream reported: https://bugs.ruby-lang.org/issues/12437
# rOCCI-core upstream notified
Patch0:         ftbfs-ruby23.patch

BuildArch:      noarch
BuildRequires:  ruby(release) >= 1.9.3
BuildRequires:  rubygems-devel
BuildRequires:  rubygem(activesupport) => 4.0.0
BuildRequires:  rubygem(hashie)
BuildRequires:  rubygem(json_spec)
BuildRequires:  rubygem(rspec)
BuildRequires:  rubygem(settingslogic) >= 2.0.9
BuildRequires:  rubygem(uuidtools) >= 2.1.3
%if 0%{?rhel} && 0%{?rhel} <= 7
BuildRequires:  rubygem(minitest5)
Requires:       ruby(release) >= 1.9.3
Requires:       ruby(rubygems)
Requires:       rubygem(activesupport) => 4.0.0
Requires:       rubygem(hashie)
Requires:       rubygem(json)
Requires:       rubygem(settingslogic) >= 2.0.9
Requires:       rubygem(uuidtools) >= 2.1.3
Provides:       rubygem(%{gem_name}) = %{version}-%{release}
%endif
Provides:       rOCCI-core = %{version}-%{release}
Provides:       rubygem(occi-core) = %{version}-%{release}
Provides:       rubygem-occi-core = %{version}-%{release}
Obsoletes:      rubygem-occi-core < 4.3.5-3

%description
OCCI is a collection of classes to simplify the implementation of the Open
Cloud Computing API in Ruby.


%package doc
Summary:        Documentation for %{name}
Group:          Documentation
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}
Provides:       rubygem-occi-core-doc = %{version}-%{release}
Obsoletes:      rubygem-occi-core-doc < 4.3.5-3

%description doc
Documentation for %{name}.


%prep
gem unpack %{SOURCE0}

%setup -q -D -T -n %{original_gem_name}-%{version}
%patch0 -p1

# patch the code to use occi4 instead of occi
rm -rfv lib/occi4/
mv -v lib/occi lib/occi4
mv -v lib/%{original_gem_name}.rb lib/%{gem_name}.rb
find . -type f -name \*.rb -exec sed -i -e 's,\(require .occi\)/,\14/,' {} \;
find . -type f -name \*.rb -exec sed -i -e 's,\(require .occi-core\)\(.\),\14\2,' {} \;

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
# modify gemspec with new gem name and include path
rm -fv %{original_gem_name}.gemspec
sed -i -e 's|\(\.name\)\s*=.*|\1 = "%{gem_name}"|' %{gem_name}.gemspec
sed -i \
  -e 's|lib/occi/|lib/occi4/|g' \
  -e 's|lib/occi-core\.rb|lib/occi-core4\.rb|g' \
  -e 's|%{original_gem_name}.gemspec|%{gem_name}.gemspec|' \
  %{gem_name}.gemspec

# relax dependencies
sed -i -e 's|\(%q<activesupport>.*,\) \[.*\]|\1 [">= 4.0.0"]|' %{gem_name}.gemspec
sed -i -e 's|\(%q<hashie>.*,\) \[.*\]|\1 [">= 2.0.5"]|' %{gem_name}.gemspec
sed -i -e 's|\(%q<json>.*,\) \[.*\]|\1 [">= 1.7.7"]|' %{gem_name}.gemspec


%build
gem build %{gem_name}.gemspec

%gem_install


%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/


%check
# UTF-8 characters in test scripts
# https://github.com/EGI-FCTF/rOCCI-core/issues/20
pushd .%{gem_instdir}
LANG=cs_CZ.UTF-8 rspec -Ilib spec
popd


%files
%doc %{gem_instdir}/AUTHORS
%doc %{gem_instdir}/README.md
%license %{gem_instdir}/LICENSE
%dir %{gem_instdir}/
%{gem_libdir}/
%{gem_instdir}/config/
%exclude %{gem_cache}
%exclude %{gem_instdir}/.gitignore
%exclude %{gem_instdir}/.rspec
%exclude %{gem_instdir}/.travis.yml
%exclude %{gem_instdir}/.yardopts
%exclude %{gem_instdir}/spec
%exclude %{gem_instdir}/Gemfile
%exclude %{gem_instdir}/Rakefile
%exclude %{gem_instdir}/%{gem_name}.gemspec
%{gem_spec}

%files doc
%doc %{gem_docdir}/


%changelog
* Tue Jul 11 2017 František Dvořák <valtri@civ.zcu.cz> - 4.3.5-3
- Modify as the new compatibility package providing occi-core 4.x

* Tue Feb 21 2017 František Dvořák <valtri@civ.zcu.cz> - 4.3.5-2
- Fix dependencies relaxation for F26+

* Fri Feb 17 2017 František Dvořák <valtri@civ.zcu.cz> - 4.3.5-1
- Update to 4.3.5 (#1417328)
- Added rOCCI-core provide

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 4.3.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jul 27 2016 František Dvořák <valtri@civ.zcu.cz> - 4.3.2-5
- Relax dependency on rails (for F25 with rails 5)
- Updates for EPEL 7

* Sun Jun 19 2016 František Dvořák <valtri@civ.zcu.cz> - 4.3.2-4
- FTBFS with ruby >= 2.3 (#1308057)

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 4.3.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Dec 01 2014 František Dvořák <valtri@civ.zcu.cz> - 4.3.2-1
- Update to 4.3.2
- Removed rails >= 4.1 compatibility patch
- The license file marked by %%license macro
- Removed tests and build files

* Thu Sep 4 2014 František Dvořák <valtri@civ.zcu.cz> - 4.2.16-1
- Initial package
